//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 LimeGreen  
#property indicator_color2 LimeGreen  
#property indicator_color3 PaleVioletRed
#property indicator_color4 PaleVioletRed
#property indicator_color5 DarkGray
#property indicator_color6 Gold
#property indicator_width1 2
#property indicator_width3 2
#property indicator_width5 2
#property indicator_width6 2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern string ForSymbol       = "";
extern double FastPaCycles    = 0.5;
extern double FastPaFilter    = 1.0;
extern double SlowPaCycles    = 2.0;
extern double SlowPaFilter    = 1.0;
extern double SignalPaCycles  = 0.5;
extern double SignalPaFilter  = 1.0;
extern int    Price           = PRICE_CLOSE;
extern bool   Invert          = false;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   Interpolate     = true;

//
//
//
//
//

double macdHuu[];
double macdHud[];
double macdHdu[];
double macdHdd[];
double macd[];
double signal[];
double slope[];
double trend[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,macdHuu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macdHud); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,macdHdd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,macdHdu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,macd);
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,slope);
   SetIndexBuffer(7,trend);

      //
      //
      //
      //
      //
         
         if (StringTrimLeft(StringTrimRight(ForSymbol))=="") ForSymbol = Symbol();
            indicatorFileName = WindowExpertName();
            returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
            calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
            timeFrame         = stringToTimeFrame(TimeFrame);

      //
      //
      //
      //
      //
      
      IndicatorShortName(ForSymbol+" "+timeFrameToString(timeFrame)+" pa daptive zlema MACD ("+DoubleToStr(FastPaCycles,2)+","+DoubleToStr(SlowPaCycles,2)+","+DoubleToStr(SignalPaCycles,2)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { macdHuu[0] = limit; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || (timeFrame==Period() && ForSymbol==Symbol()))
   {
    	for(int i = limit; i >= 0; i--)
      {
         double price     = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         double FastEMA   = iHilbertPhase(price,FastPaFilter  ,FastPaCycles  ,i,0);
         double SlowEMA   = iHilbertPhase(price,SlowPaFilter  ,SlowPaCycles  ,i,1);
         double SignalEMA = iHilbertPhase(price,SignalPaFilter,SignalPaCycles,i,2);
            if (Invert)
                  macd[i] = iZlema(price,SlowEMA,i,0)-iZlema(price,FastEMA,i,1);
            else  macd[i] = iZlema(price,FastEMA,i,0)-iZlema(price,SlowEMA,i,1);
            signal[i]  = iZlema(macd[i],SignalEMA,i,2);
            macdHuu[i] = EMPTY_VALUE;
            macdHud[i] = EMPTY_VALUE;
            macdHdd[i] = EMPTY_VALUE;
            macdHdu[i] = EMPTY_VALUE;
            slope[i]   = slope[i+1];
            trend[i]   = trend[i+1];
            if (macd[i]>macd[i+1]) slope[i] =  1;
            if (macd[i]<macd[i+1]) slope[i] = -1;
            if (macd[i]>0)         trend[i] =  1;
            if (macd[i]<0)         trend[i] = -1;
            if (trend[i]==1)
               if (slope[i]==1)
                     macdHuu[i] = macd[i];
               else  macdHud[i] = macd[i];
            if (trend[i]==-1)
               if (slope[i]==1)
                     macdHdu[i] = macd[i];
               else  macdHdd[i] = macd[i];
      }
      manageAlerts();
      return(0);           
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMin(Bars-1,iCustom(ForSymbol,timeFrame,indicatorFileName,"returnBars",0,0));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         macd[i]    = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue","",FastPaCycles,FastPaFilter,SlowPaCycles,SlowPaFilter,SignalPaCycles,SignalPaFilter,Price,Invert,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,4,y);
         signal[i]  = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue","",FastPaCycles,FastPaFilter,SlowPaCycles,SlowPaFilter,SignalPaCycles,SignalPaFilter,Price,Invert,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,5,y);
         slope[i]   = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue","",FastPaCycles,FastPaFilter,SlowPaCycles,SlowPaFilter,SignalPaCycles,SignalPaFilter,Price,Invert,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,6,y);
         trend[i]   = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue","",FastPaCycles,FastPaFilter,SlowPaCycles,SlowPaFilter,SignalPaCycles,SignalPaFilter,Price,Invert,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,7,y);
         macdHuu[i] = EMPTY_VALUE;
         macdHud[i] = EMPTY_VALUE;
         macdHdd[i] = EMPTY_VALUE;
         macdHdu[i] = EMPTY_VALUE;
            if (trend[i]==1)
               if (slope[i]==1)
                     macdHuu[i] = macd[i];
               else  macdHud[i] = macd[i];
            if (trend[i]==-1)
               if (slope[i]==1)
                     macdHdu[i] = macd[i];
               else  macdHdd[i] = macd[i];

         //
         //
         //
         //
         //
         
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
               {
                  macd[i+k]   = macd[i]   + (macd[i+n]   - macd[i]  )*k/n;
                  signal[i+k] = signal[i] + (signal[i+n] - signal[i])*k/n;
               }                  
   }
   for (i=limit; i>=0; i--)
   {
      if (macdHuu[i] != EMPTY_VALUE) macdHuu[i] = macd[i];
      if (macdHud[i] != EMPTY_VALUE) macdHud[i] = macd[i];
      if (macdHdd[i] != EMPTY_VALUE) macdHdd[i] = macd[i];
      if (macdHdu[i] != EMPTY_VALUE) macdHdu[i] = macd[i];
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" pa adaptive Zlema MACD trend changed to "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"pa adaptive Zlema MACD"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workZl[][6];
#define _price 0
#define _zlema 1

double iZlema(double price, double length, int r, int instanceNo=0)
{
   if (ArrayRange(workZl,0)!=Bars) ArrayResize(workZl,Bars); r = Bars-r-1; instanceNo *= 2;

   //
   //
   //
   //
   //

   double alpha = 2.0/(1.0+length); 
   int    per   = (length-1.0)/2.0; 

   workZl[r][_price+instanceNo] = price;
   if (r<per)
          workZl[r][_zlema+instanceNo] = price;
   else   workZl[r][_zlema+instanceNo] = workZl[r-1][_zlema+instanceNo]+alpha*(2.0*price-workZl[r-per][_price+instanceNo]-workZl[r-1][_zlema+instanceNo]);
   return(workZl[r][_zlema+instanceNo]);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workHil[][27];
#define _price      0
#define _smooth     1
#define _detrender  2
#define _period     3
#define _instPeriod 4
#define _phase      5
#define _deltaPhase 6
#define _Q1         7
#define _I1         8

#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iHilbertPhase(double price, double filter, double cyclesToReach, int i, int s=0)
{
   if (ArrayRange(workHil,0)!=Bars) ArrayResize(workHil,Bars);
   int r = Bars-i-1; s = s*9;
      
   //
   //
   //
   //
   //
      
      workHil[r][s+_price]      = price;
      workHil[r][s+_smooth]     = (4.0*workHil[r][s+_price]+3.0*workHil[r-1][s+_price]+2.0*workHil[r-2][s+_price]+workHil[r-3][s+_price])/10.0;
      workHil[r][s+_detrender]  = calcComp(r,_smooth,s);
      workHil[r][s+_Q1]         = 0.15*calcComp(r,_detrender,s)  +0.85*workHil[r-1][s+_Q1];
      workHil[r][s+_I1]         = 0.15*workHil[r-3][s+_detrender]+0.85*workHil[r-1][s+_I1];
      workHil[r][s+_phase]      = workHil[r-1][s+_phase];
      workHil[r][s+_instPeriod] = workHil[r-1][s+_instPeriod];

      //
      //
      //
      //
      //
           
         if (MathAbs(workHil[r][s+_I1])>0)
                     workHil[r][s+_phase] = 180.0/Pi*MathArctan(MathAbs(workHil[r][s+_Q1]/workHil[r][s+_I1]));
           
         if (workHil[r][s+_I1]<0 && workHil[r][s+_Q1]>0) workHil[r][s+_phase] = 180.0-workHil[r][s+_phase];
         if (workHil[r][s+_I1]<0 && workHil[r][s+_Q1]<0) workHil[r][s+_phase] = 180.0+workHil[r][s+_phase];
         if (workHil[r][s+_I1]>0 && workHil[r][s+_Q1]<0) workHil[r][s+_phase] = 360.0-workHil[r][s+_phase];

      //
      //
      //
      //
      //
                        
      workHil[r][s+_deltaPhase] = workHil[r-1][s+_phase]-workHil[r][s+_phase];

         if (workHil[r-1][s+_phase]<90.0 && workHil[r][s+_phase]>270.0)
             workHil[r][s+_deltaPhase] = 360.0+workHil[r-1][s+_phase]-workHil[r][s+_phase];
             workHil[r][s+_deltaPhase] = MathMax(MathMin(workHil[r][s+_deltaPhase],60),7);
      
            //
            //
            //
            //
            //
                  
            double alpha    = 2.0/(1.0+MathMax(filter,1));
            double phaseSum = 0; for (int k=0; phaseSum<cyclesToReach*360.0 && (r-k)>0; k++) phaseSum += workHil[r-k][s+_deltaPhase];
         
               if (k>0) workHil[r][s+_instPeriod]= k;
                  workHil[r][s+_period] = workHil[r-1][s+_period]+alpha*(workHil[r][s+_instPeriod]-workHil[r-1][s+_period]);
   return (workHil[r][s+_period]);
}

//
//
//
//
//

double calcComp(int r, int from, int s)
{
   return((0.0962*workHil[r  ][s+from] + 
           0.5769*workHil[r-2][s+from] - 
           0.5769*workHil[r-4][s+from] - 
           0.0962*workHil[r-6][s+from]) * (0.075*workHil[r-1][s+_period] + 0.54));
}

//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}


